package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10062DaBaoResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10062SendBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10062DaBaoJnmy extends ProtBase {

	private final short iTaskCode10062 = 10062;

	private Gson gson;

	private Prot10062DaBaoResult res;

	public Prot10062DaBaoJnmy() {
		gson = new Gson();
	}

	/**
	 * @return the res
	 */
	public Prot10062DaBaoResult getRes() {
		return res;
	}

	/**
	 * @param res
	 *            the res to set
	 */
	public void setRes(Prot10062DaBaoResult res) {
		this.res = res;
	}

	public void dealDaBao(SocketCreate create, Prot10062SendBean daBaoBean)
			throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), daBaoBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10062SendBean daBaoBean)
			throws IOException {
		if (socket.isConnected()) {

			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10062, "开始发送登录信息");
				sendProt(dos, daBaoBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10062SendBean daBaoBean)
			throws IOException {
		String bodyContent = gson.toJson(daBaoBean).toString();
		System.out.println("---json" + bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10062, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10062, "获取接收的数据");
		recHeader(dis);

		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10062, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10062DaBaoResult.class);
		}
		recCheckCode(dis);
	}

}
